import { Types } from "./gateway";
export interface Item<T extends Types> {
    sku?: T extends "One-Time" ? string : never;
    name?: T extends "One-Time" ? string : never;
    description?: T extends "One-Time" ? string : never;
    price: T extends "One-Time" ? number : string;
    quantity?: number;
}
export interface ItemOptions<T extends Types> {
    description?: string;
    currency?: T extends "One-Time" ? string : never;
    items: Array<Item<T>>;
}
export interface ReturnItem<T extends Types> {
    sku: T extends "One-Time" ? string : never;
    name: T extends "One-Time" ? string : never;
    description?: T extends "One-Time" ? string : never;
    currency: T extends "One-Time" ? string : never;
    price: T extends "One-Time" ? number : never;
    quantity: number;
}
export interface ItemsOutput<T extends Types> {
    items: Array<ReturnItem<T>>;
    description?: string;
    currency: string;
    total: number;
}
export declare class Items<T extends Types> {
    protected Options: ItemOptions<T>;
    protected DefaultCurrency: string;
    protected Output: ItemsOutput<T>;
    constructor(Options: ItemOptions<T>);
    get: (type: T) => ItemsOutput<T>;
    getOptions: () => ItemOptions<T>;
}
