"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Items = void 0;
const exceptions_1 = require("./exceptions");
class Items {
    constructor(Options) {
        this.Options = Options;
        this.DefaultCurrency = "USD";
        this.Output = {
            items: [],
            description: this.Options.description,
            currency: this.Options.currency || this.DefaultCurrency,
            total: 0,
        };
        this.get = (type) => {
            // Resolve Items
            this.Output.items = this.Options.items.map((item, index) => {
                var _a, _b, _c;
                return ({
                    sku: type === "One-Time" ? item.sku || Date.now() + index : undefined,
                    currency: type === "One-Time"
                        ? ((_a = this.Options.currency) === null || _a === void 0 ? void 0 : _a.toUpperCase()) || this.DefaultCurrency
                        : undefined,
                    name: type === "One-Time" ? item.name : undefined,
                    description: item.description,
                    price: type === "One-Time"
                        ? parseFloat((_c = (_b = (item.price || 0)).toFixed) === null || _c === void 0 ? void 0 : _c.call(_b, 2))
                        : item.price,
                    quantity: (item.quantity || 0) > 0 ? item.quantity : 1,
                });
            });
            if (type === "One-Time")
                // Create Total Amount
                this.Output.total = parseFloat(this.Output.items
                    .reduce((p, c) => p + c.price * c.quantity, 0)
                    .toFixed(2));
            else if (type !== "Subscription")
                throw new exceptions_1.GatewayException(`Invalid Payment Type '${type}' has been provided!`);
            // Return Resolved Output Items
            return this.Output;
        };
        this.getOptions = () => this.Options;
        // Validate Currency
        if (typeof this.Options.currency === "string" &&
            this.Options.currency.length > 3)
            throw new exceptions_1.GatewayException(`Invalid or currency has not been provided!`);
    }
}
exports.Items = Items;
