import { Mode, Gateway, Methods } from "../../gateway";
import { Stripe } from "stripe";
import { Items } from "../../items";
import { CheckoutConfiguration, CreateIntentResponse } from "./one-time";
export interface ExecuteOptions {
    body: any;
    signature?: string;
}
export interface ExecuteIntentResponse {
    method: Methods;
    mode: Mode;
    response: {
        invoice: Stripe.Response<Stripe.Invoice>;
        payment_intent: Stripe.Response<Stripe.PaymentIntent>;
    };
}
export declare const EpicStripePaymentsSubscription: (Parent: Gateway<"Stripe">) => {
    new (configuration?: CheckoutConfiguration | undefined): {
        Instance: Stripe;
        Configuration?: CheckoutConfiguration | undefined;
        configure: (configuration: CheckoutConfiguration) => any;
        create: (Items: Items<"Subscription">, custom?: {
            cancel_url?: string | undefined;
            payment_method_types?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[] | undefined;
            success_url?: string | undefined;
            allow_promotion_codes?: boolean | undefined;
            billing_address_collection?: "required" | "auto" | undefined;
            client_reference_id?: string | undefined;
            customer?: string | undefined;
            customer_email?: string | undefined;
            discounts?: Stripe.Checkout.SessionCreateParams.Discount[] | undefined;
            expand?: string[] | undefined;
            line_items?: Stripe.Checkout.SessionCreateParams.LineItem[] | undefined;
            locale?: "auto" | "tr" | "de" | "en" | "fr" | "nl" | "es" | "it" | "pl" | "bg" | "cs" | "da" | "el" | "en-GB" | "es-419" | "et" | "fi" | "fr-CA" | "hu" | "id" | "ja" | "lt" | "lv" | "ms" | "mt" | "nb" | "pt" | "pt-BR" | "ro" | "ru" | "sk" | "sl" | "sv" | "zh" | "zh-HK" | "zh-TW" | undefined;
            metadata?: Stripe.MetadataParam | undefined;
            mode?: "setup" | "payment" | "subscription" | undefined;
            payment_intent_data?: Stripe.Checkout.SessionCreateParams.PaymentIntentData | undefined;
            setup_intent_data?: Stripe.Checkout.SessionCreateParams.SetupIntentData | undefined;
            shipping_address_collection?: Stripe.Checkout.SessionCreateParams.ShippingAddressCollection | undefined;
            submit_type?: "auto" | "book" | "donate" | "pay" | undefined;
            subscription_data?: Stripe.Checkout.SessionCreateParams.SubscriptionData | undefined;
        } | undefined) => Promise<CreateIntentResponse>;
        execute: (options: ExecuteOptions) => Promise<ExecuteIntentResponse>;
    };
};
